﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Runtime.CompilerServices


Public Class CountryViewModel
    Inherits BaseViewModel

    Public Sub New()
    End Sub


    'geniale sache das direkt beim erstellen mit aufzurufen, so müllt es das MainViewModel nicht voll
    Public Shared Function Seed() As ObservableCollection(Of CountryViewModel)


        Dim AvailableCountrys = New ObservableCollection(Of CountryViewModel)

        AvailableCountrys.Add(New CountryViewModel("Austria", "EMA-AT", "TCDE-AUT-S"))
        AvailableCountrys.Add(New CountryViewModel("Belgium", "EMA-BL", "TCDE-BEL-S"))
        AvailableCountrys.Add(New CountryViewModel("France", "EMA-FR", "TCDE-FRA-S"))
        AvailableCountrys.Add(New CountryViewModel("Germany", "EMA-DE", "TCDE-DEU-S"))
        AvailableCountrys.Add(New CountryViewModel("Italy", "EMA-IT", "TCDE-ITA-S"))
        AvailableCountrys.Add(New CountryViewModel("Netherlands", "EMA-NL", "TCDE-NLD-S"))
        AvailableCountrys.Add(New CountryViewModel("Spain", "EMA-ES", "TCDE-ESP-S"))

        Return AvailableCountrys

    End Function

    'Aus dem Land-String wird hier auch per Funktionsaufruf von StringToUri direkt der Pfad für das Icon geladen
    Public Sub New(_coName As String, _coDayBookSet As String, _coTaxEnvironment As String)
        CountryName = _coName : CountryDayBookSet = _coDayBookSet : CountryTaxEnvironment = _coTaxEnvironment
        CountryFlagImageUri = StringToImageURI(_coName) : InvoiceText = UriToText(StringToTextFileURI(_coName))
    End Sub

    Private _countryName As String = String.Empty
    Public Property CountryName() As String
        Get
            Return _countryName
        End Get
        Set(ByVal value As String)
            ChangePropIfDifferent(value, _countryName)
        End Set
    End Property

    Private _countryDayBookSet As String = String.Empty
    Public Property CountryDayBookSet() As String
        Get
            Return _countryDayBookSet
        End Get
        Set(ByVal value As String)
            ChangePropIfDifferent(value, _countryDayBookSet)
        End Set
    End Property

    Private _countryTaxEnvironment As String = String.Empty
    Public Property CountryTaxEnvironment() As String
        Get
            Return _countryTaxEnvironment
        End Get
        Set(ByVal value As String)
            ChangePropIfDifferent(value, _countryTaxEnvironment)
        End Set
    End Property

    Private _countryflagImageUri As Uri = StringToImageURI("Error")
    Public Property CountryFlagImageUri() As Uri
        Get
            Return _countryflagImageUri
        End Get
        Set(ByVal value As Uri)
            ChangePropIfDifferent(value, _countryflagImageUri)
        End Set
    End Property

    Private _invoiceText As String = String.Empty
    Public Property InvoiceText() As String
        Get
            Return _invoiceText
        End Get
        Set(ByVal value As String)
            ChangePropIfDifferent(value, _invoiceText)
        End Set
    End Property


    Public Overrides Function ToString() As String
        Return $"{CountryName}"
    End Function



    'Gibt basierend auf dem erhaltenen Land eine passende Uri zurück
    Private Shared Function StringToImageURI(ByVal BaseUriString As String) As Uri
        Return New Uri($"pack://application:,,,/Advanced Invoice Support;component/Assets/Images/{BaseUriString}.png", UriKind.RelativeOrAbsolute)
    End Function



    'Gibt basierend auf dem erhaltenen Land eine passende Uri zurück
    Private Shared Function StringToTextFileURI(ByVal BaseUriString As String) As Uri

        Select Case BaseUriString
            Case "Germany"
                Return New Uri($"pack://application:,,,/Advanced Invoice Support;component/Assets/Textpresets/Germany IVT", UriKind.RelativeOrAbsolute)
            Case "Austria"
                Return New Uri($"pack://application:,,,/Advanced Invoice Support;component/Assets/Textpresets/Austria IVT", UriKind.RelativeOrAbsolute)
            Case Else
                Return New Uri($"pack://application:,,,/Advanced Invoice Support;component/Assets/Textpresets/General IVT", UriKind.RelativeOrAbsolute)
        End Select

    End Function


    'Wandelt eine erhaltene Uri zum zugerhörigen "text" der Resource um
    Private Shared Function UriToText(ByVal TextUri As Uri) As String
        Dim ResStream = Application.GetResourceStream(TextUri)
        Dim ResStreamText = String.Empty
        Using Reader As New IO.StreamReader(ResStream.Stream)
            ResStreamText = Reader.ReadToEnd
        End Using

        Return ResStreamText
    End Function

End Class

